/*
 * StringWriterAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _STRING_WRITER_ABSTRACTION_HPP_
#define _STRING_WRITER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <factory/StringDataFactory.hpp>

namespace abstraction {

template < class ParamType >
class StringWriterAbstraction : public UnaryOperationAbstraction < std::string, const ParamType & > {
public:
	virtual bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->m_params );
		this->m_data = factory::StringDataFactory::toString ( abstraction::retrieveValue < const ParamType & > ( param.first, param.second ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _STRING_WRITER_ABSTRACTION_HPP_ */
