/*
 * PrimitiveFromStringLexer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrimitiveFromStringLexer.h"

namespace primitive {

PrimitiveFromStringLexer::Token PrimitiveFromStringLexer::next(std::istream& in) {
	PrimitiveFromStringLexer::Token token;
	token.type = TokenType::ERROR;
	token.value = "";
	token.raw = "";
	char character;

L0:
	character = in.get();
	if ( in.eof ( ) || character == EOF ) {
		token.type = TokenType::TEOF;
		return token;
	} else if ( isspace ( character ) ) {
		token.raw += character;
		goto L0;
	} else if((character >= 'a' && character <= 'z') || (character >= 'A' && character <= 'Z') || character == '_' ) {
		token.type = TokenType::STRING;
		token.value += character;
		token.raw += character;
		goto L1;
	} else if(character >= '0' && character <= '9') {
		token.type = TokenType::INTEGER;
		token.value += character;
		token.raw += character;
		goto L2;
	} else {
		in.clear ( );
		in.unget ( );
		putback(in, std::move(token));
		token.type = TokenType::ERROR;
		return token;
	}
L1:
	character = in.get();
	if(in.eof()) {
		return token;
	} else if ( ( character >= 'a' && character <= 'z' ) || ( character >= 'A' && character <= 'Z' ) || character == '_' || ( character >= '0' && character <= '9' ) ) {
		token.value += character;
		token.raw += character;
		goto L1;
	} else {
		in.clear ( );
		in.unget ( );
		return token;
	}
L2:
	character = in.get();
	if(in.eof()) {
		return token;
	} else if(character >= '0' && character <= '9') {
		token.value += character;
		token.raw += character;
		goto L1;
	} else {
		in.clear ( );
		in.unget ( );
		return token;
	}
}

void PrimitiveFromStringLexer::putback(std::istream& in, PrimitiveFromStringLexer::Token token) {
	in.clear();

	while(!token.raw.empty()) {
		in.putback(token.raw.back());
		token.raw.pop_back();
	}
}

} /* namespace primitive */
