/*
 * RTEFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef RTE_FROM_STRING_LEXER_H_
#define RTE_FROM_STRING_LEXER_H_

#include <alib/string>
#include <alib/istream>

namespace rte {

class RTEFromStringLexer {
public:
	enum class TokenType {
		LPAR,
		RPAR,
		PLUS,
		STAR,
		DOT,
		COMMA,
		EMPTY,
		RANK,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream& input);
	static void putback(std::istream&, Token token);
};

} /* namespace rte */

#endif /* RTE_FROM_STRING_LEXER_H_ */
